(defpackage :rechner
  (:add-use-defaults t)
  (:use :capi))

(in-package :rechner)

;; === Ein rechts ausgerichtetes Display ===
;; siehe auch http://thread.gmane.org/gmane.lisp.lispworks.general/1490/focus=1505

(define-interface main-display ()
  ()
  (:panes
   (display display-pane :visible-border nil))
  (:layouts
   (l1 row-layout '(display)
       :visible-max-width nil :x-adjust :right :visible-border t :internal-border 1 :background :white)))

(defmethod main-display-text ((self main-display))
  (with-slots (display) self
    (display-pane-text display)))

(defmethod (setf main-display-text) (value (self main-display))
  (with-slots (display) self
    (setf (display-pane-text display) value)))

(defun test ()
  "Display ausprobieren."
  (let ((d (make-instance 'main-display)))
    (setf (main-display-text d) "Hallo")
    (display d)
    (main-display-text d)))

;; === Unser Rechner (ein Anfang :)) ===

(define-interface rechner ()
  ()
  (:panes
   (display main-display)
   (keys push-button-panel 
         :items '(1 2 3 + 4 5 6 - 7 8 9 * "." 0 = /)
         :layout-class 'capi:grid-layout 
         :layout-args '(:columns 4)
         :selection-callback 'on-button))
  (:layouts
   (l1 column-layout '(display keys)))
  (:default-initargs
   :auto-menus nil
   :title "Rechner"))

(defun on-button (data intf)
  (with-slots (display) intf
    (setf (main-display-text display)
          (concatenate 'string 
                       (main-display-text display)
                       (format nil "~a" data)))))

(defun main ()
  (display (make-instance 'rechner)))
